uk.ac.starlink.gbin

## Class GbinTableBuilder

- java.lang.Object
- - uk.ac.starlink.table.formats.DocumentedTableBuilder
  - - uk.ac.starlink.gbin.GbinTableBuilder

- All Implemented Interfaces:
    Documented, DocumentedIOHandler, TableBuilder

      public class GbinTableBuilder
      extends DocumentedTableBuilder

  TableBuilder implementation for GBIN files.
  Since:
    14 Aug 2014

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static ValueInfo` | `BUILDDESCRIP_INFO` ValueInfo for GBIN build description string.
    `static ValueInfo` | `CLASSNAME_INFO` ValueInfo for GBIN row object classname.
    `static ValueInfo` | `COLDETAIL_INFO` ValueInfo for Gaia column detailed description string.
    `static ValueInfo` | `DESCRIP_INFO` ValueInfo for Gaia table description string.
    `static ValueInfo` | `GAIATABLENAME_INFO` ValueInfo for well-known Gaia table name.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `GbinTableBuilder()` Constructs a builder with default options.
    `GbinTableBuilder(GbinTableProfile profile)` Constructs a builder with custom options.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canImport(java.awt.datatransfer.DataFlavor flavor)` Indicates whether this builder is able to turn a resource of media type indicated by `flavor` into a table.
    `boolean` | `canStream()` Indicates whether this handler can read tables from a stream.
    `boolean` | `docIncludesExample()` Indicates whether the serialization of some (short) example table should be added to the user documentation for this handler.
    `java.lang.String` | `getFormatName()` Returns "GBIN".
    `boolean` | `getHierarchicalNames()` Returns value of `GbinTableProfile.isHierarchicalNames()`.
    `GbinTableProfile` | `getProfile()` Returns the object configuring how GBIN files are mapped to tables.
    `boolean` | `getReadMeta()` Returns value of `GbinTableProfile.isReadMeta()`.
    `java.lang.String` | `getXmlDescription()` Returns user-directed documentation in XML format.
    `void` | `isSortedMethods(boolean isSortedMethods)` Configures value of `GbinTableProfile.isSortedMethods()`.
    `StarTable` | `makeStarTable(DataSource datsrc, boolean wantRandom, StoragePolicy storage)` Constructs a `StarTable` based on a given `DataSource`.
    `void` | `setHierarchicalNames(boolean isHierarchicalNames)` Configures value of `GbinTableProfile.isHierarchicalNames()`
    `void` | `setReadMeta(boolean isReadMeta)` Configures value of `GbinTableProfile.isReadMeta()`.
    `void` | `setTestMagic(boolean isTestMagic)` Configures value of `GbinTableProfile.isTestMagic()`.
    `void` | `streamStarTable(java.io.InputStream in, TableSink sink, java.lang.String pos)` Reads a table from an input stream and writes it a row at a time to a sink.

    - ### Methods inherited from class uk.ac.starlink.table.formats.DocumentedTableBuilder

      `getExtensions, looksLikeFile`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface uk.ac.starlink.table.formats.DocumentedIOHandler

      `matchesExtension, readText, toLink`

- - ### Field Detail

    - #### CLASSNAME_INFO

          public static final ValueInfo CLASSNAME_INFO

      ValueInfo for GBIN row object classname.

    - #### GAIATABLENAME_INFO

          public static final ValueInfo GAIATABLENAME_INFO

      ValueInfo for well-known Gaia table name.

    - #### DESCRIP_INFO

          public static final ValueInfo DESCRIP_INFO

      ValueInfo for Gaia table description string.

    - #### COLDETAIL_INFO

          public static final ValueInfo COLDETAIL_INFO

      ValueInfo for Gaia column detailed description string.

    - #### BUILDDESCRIP_INFO

          public static final ValueInfo BUILDDESCRIP_INFO

      ValueInfo for GBIN build description string.

  - ### Constructor Detail

    - #### GbinTableBuilder

          public GbinTableBuilder()

      Constructs a builder with default options.

    - #### GbinTableBuilder

          public GbinTableBuilder(GbinTableProfile profile)

      Constructs a builder with custom options.
      Parameters:
        `profile` - configures how GBIN files will be mapped to a table

  - ### Method Detail

    - #### getProfile

          public GbinTableProfile getProfile()

      Returns the object configuring how GBIN files are mapped to tables. Note this may be a modified version of the object supplied at construction time.
      Returns:
        configuration profile

    - #### getFormatName

          public java.lang.String getFormatName()

      Returns "GBIN".
      Returns:
        one-word description of this handler's format

    - #### canImport

          public boolean canImport(java.awt.datatransfer.DataFlavor flavor)

      Description copied from interface: `TableBuilder`
      Indicates whether this builder is able to turn a resource of media type indicated by `flavor` into a table. It should return `true` if it thinks that its `TableBuilder.streamStarTable(java.io.InputStream, uk.ac.starlink.table.TableSink, java.lang.String)` method stands a reasonable chance of successfully constructing a `StarTable` from a `DataSource` whose input stream is described by the `DataFlavor` `flavor`. It will typically make this determination based on the flavor's MIME type.

      This method should only return `true` if the flavor looks like it is targeted at this builder; for instance a builder which uses a text-based format should return false for a flavor which indicates a MIME type of `text/plain`.

      This method is used in supporting drag and drop functionality (see `StarTableFactory.canImport(java.awt.datatransfer.DataFlavor[])`).

      Parameters:
        `flavor` - the DataFlavor whose suitability as stream input is to be assessed
      Returns:
        `true` iff this builder reckons it stands a good chance of turning a stream of type `flavor` into a `StarTable`

    - #### streamStarTable

          public void streamStarTable(java.io.InputStream in,
                                      TableSink sink,
                                      java.lang.String pos)
                               throws java.io.IOException

      Description copied from interface: `TableBuilder`
      Reads a table from an input stream and writes it a row at a time to a sink. Not all implementations will be able to do this; for instance, extracting the table from the data may be a two-pass process. Implementations which are unable to perform this function should throw a `TableFormatException`.

      The input stream should be prepared for use prior to calling this method, so implementations should not in general attempt to decompress or buffer `istrm`.

      Parameters:
        `in` - input stream containing table data
        `sink` - destination of the table
        `pos` - position identifier describing the location of the table within the stream; see `DataSource.getPosition()` (may be null)
      Throws:
        `TableFormatException` - if the table can't be streamed or the data is malformed
        `java.io.IOException` - if some other error occurs

    - #### makeStarTable

          public StarTable makeStarTable(DataSource datsrc,
                                         boolean wantRandom,
                                         StoragePolicy storage)
                                  throws java.io.IOException

      Description copied from interface: `TableBuilder`
      Constructs a `StarTable` based on a given `DataSource`. If the source is not recognised or this builder does not know how to construct a table from it, then a `TableFormatException` should be thrown. If this builder thinks it should be able to handle the source but an error occurs during processing, an `IOException` can be thrown.

      The `wantRandom` parameter is used to indicate whether, ideally, a random-access table should be returned. There is no requirement for the builder to honour this request, but if it knows how to make both random and non-random tables, it can use this flag to decide which to return.

      Note: the presence of the `wantRandom` parameter is somewhat misleading. TableBuilder implementations usually should, and do, ignore it (it would be removed from the interface if it were not for backward compatibility issues). Regardless of the value of this parameter, implementations should return a random-access table only if it is easy for them to do so; in particular they should not use the supplied `storagePolicy`, or any other resource-expensive measure, to randomise a sequential table just because the `wantRandom` parameter is true.

      Parameters:
        `datsrc` - the DataSource containing the table resource
        `wantRandom` - whether, preferentially, a random access table should be returned
        `storage` - a StoragePolicy object which may be used to supply scratch storage if the builder needs it
      Returns:
        a StarTable made out of `datsrc`
      Throws:
        `TableFormatException` - if the table is not of a kind that can be handled by this handler
        `java.io.IOException` - if an unexpected I/O error occurs during processing

    - #### canStream

          public boolean canStream()

      Description copied from class: `DocumentedTableBuilder`
      Indicates whether this handler can read tables from a stream.
      Specified by:
        `canStream` in class `DocumentedTableBuilder`
      Returns:
        true iff this handler can read from streams

    - #### docIncludesExample

          public boolean docIncludesExample()

      Description copied from interface: `DocumentedIOHandler`
      Indicates whether the serialization of some (short) example table should be added to the user documentation for this handler. Binary formats, or instances for which the `Documented.getXmlDescription()` method already includes some example output, should return false.
      Returns:
        true if the user documentation would benefit from the addition of an example serialization

    - #### getXmlDescription

          public java.lang.String getXmlDescription()

      Description copied from interface: `Documented`
      Returns user-directed documentation in XML format.

      The output should be a sequence of one or more <P> elements, using XHTML-like XML. Since rendering may be done in a number of contexts however, use of the full range of XHTML elements is discouraged. Where possible, the content should stick to simple markup such as the elements P, A, UL, OL, LI, DL, DT, DD EM, STRONG, I, B, CODE, TT, PRE.

      Returns:
        XML description of this object

    - #### setReadMeta

          @ConfigMethod(property="readMeta",
                        doc="<p>Configures whether the GBIN metadata will be read prior to reading the data. This may slow things down slightly, but means the row count can be determined up front, which may have benefits for downstream processing.</p>\n<p>Setting this false can prevent failing on an error related to a broken version of the zStd-jni library in GaiaTools.\nNote however that in this case the data read, though not reporting an error, will silently be missing some rows from the GBIN file.</p>\n",
                        example="false")
          public void setReadMeta(boolean isReadMeta)

      Configures value of `GbinTableProfile.isReadMeta()`.
      Parameters:
        `isReadMeta` - true to read metadata up front

    - #### getReadMeta

          public boolean getReadMeta()

      Returns value of `GbinTableProfile.isReadMeta()`.
      Returns:
        read meta flag

    - #### setHierarchicalNames

          @ConfigMethod(property="hierarchicalNames",
                        doc="<p>Configures whether column names in the output table should be forced to reflect the compositional hierarchy of their position in the element objects.\nIf set true, columns will have names like \"<code>Astrometry_Alpha</code>\", if false they may just be called \"<code>Alpha</code>\".\nIn case of name duplication however, the hierarchical form is always used.</p>\n",
                        example="true")
          public void setHierarchicalNames(boolean isHierarchicalNames)

      Configures value of `GbinTableProfile.isHierarchicalNames()`
      Parameters:
        `isHierarchicalNames` - whether to name columns hierarchically

    - #### getHierarchicalNames

          public boolean getHierarchicalNames()

      Returns value of `GbinTableProfile.isHierarchicalNames()`.
      Returns:
        hierarchical naming flag

    - #### setTestMagic

          public void setTestMagic(boolean isTestMagic)

      Configures value of `GbinTableProfile.isTestMagic()`.
      Parameters:
        `isTestMagic` - whether to read magic number from GBIN files

    - #### isSortedMethods

          public void isSortedMethods(boolean isSortedMethods)

      Configures value of `GbinTableProfile.isSortedMethods()`.
      Parameters:
        `isSortedMethods` - whether to sort method names alphabetically